/*
 $B3F%*%V%8%'%/%H$N>eN.0hLL@Q$K1~$8$F@nI}$r7hDj$7!"%Q%i%a%?%U%!%$%k$r(B
 $B=$@5$9$k%W%m%0%i%`!#(B
 $B>\$7$/$O(B modWidth_pmt.txt $B$r;2>H!#(B
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(void)
{
	char Org_PmtFile[256];
	char Mod_PmtFile[256];
	char UpperAreaFile[256];

//--------------$B$3$3$+$i(B----------------------------
	strcpy(Org_PmtFile, "test.pmt");
	strcpy(Mod_PmtFile, "test.pmtMod2");
	strcpy(UpperAreaFile, "test.upArea");

	float least_width = 10.0;
	float base_width = 600.0;
	float base_upperArea = 834.090576;
//--------------$B$3$3$^$G(B----------------------------

	float rate = (base_width - least_width) / base_upperArea;

	FILE* fp_org;
	FILE* fp_mod;
	FILE* fp_area;

	char buf[256];

	//------$B%*%V%8%'%/%H?t$r%+%&%s%H(B---------

	if((fp_area = fopen(UpperAreaFile, "r")) == NULL){
		printf("cannot open UpperAreaFile\n");
		exit(1);
	}
	int counter = 0;
	char ob_name[100];
	float ob_area;
  	while(fgets(buf, 256, fp_area) != NULL){
		if((buf[0] == '#') || (buf[0] == '\n')) continue;
    	else {
      		if (sscanf(buf, "%s %f", &ob_name, &ob_area) != 2){
				printf("UpperAreaFile is wrong.\n");
				exit(1);
			}
			counter++;
		}
	}
	fclose(fp_area);
	int Num_of_obj;
	Num_of_obj = counter;

	//------object$BL>$H3F!9$NLL@Q$rG[Ns$K3JG<(B--------

	char** obj_name;
	float obj_Uarea[Num_of_obj];

	int i, j;

	obj_name = new char*[Num_of_obj];
	for(i = 0; i < Num_of_obj; i++){
		obj_name[i] = new char[100];
	}

	if((fp_area = fopen(UpperAreaFile, "r")) == NULL){
		printf("cannot open UpperAreaFile\n");
		exit(1);
	}

	j = 0;

	while(fgets(buf, 256, fp_area) != NULL){
		if((buf[0] == '#') || (buf[0] == '\n')) continue;
		if (sscanf(buf, "%s %f", &ob_name, &ob_area) == 2){
			strcpy(obj_name[j], ob_name);
			obj_Uarea[j] = ob_area;
			j++;
		}
	}
	
	if(j != Num_of_obj){
		printf("contradiction 1 \n");
		exit(1);
	}

	//-----------------------------------
	if((fp_org = fopen(Org_PmtFile, "r")) == NULL){
		printf("cannot open Org_PmtFile\n");
		exit(1);
	}
	if((fp_mod = fopen(Mod_PmtFile, "w")) == NULL){
		printf("cannot open Mod_PmtFile\n");
		exit(1);
	}
	fprintf(fp_mod, "# %s\n", Mod_PmtFile);

	char Model_name[256], ObjectName[256];
	int O_No, R_No;
	float length, Org_width, deg, a, b;
	float New_width;
	int flag_hit, k;

	while(fgets(buf, 256, fp_org) != NULL){
		if(buf[0] == '#') continue;
		if(buf[0] == '\n'){
			fprintf(fp_mod, "%s", buf);
			continue;
		}
		if(sscanf(buf, "%s %s %d", &Model_name, &ObjectName,
				  &O_No) == 3){
			fprintf(fp_mod, "%s", buf);
			flag_hit = 0;
			for(i = 0; i < Num_of_obj; i++){
				if(strcmp(obj_name[i], ObjectName) == 0){
					flag_hit = 1;

					fgets(buf, 256, fp_org);
					// $B>e3g8L$r=q$/(B
					fprintf(fp_mod, "%s", buf); 

					fgets(buf, 256, fp_org);
					// $B2OF;%b%G%kL>Ey$r=q$/(B
					fprintf(fp_mod, "%s", buf); 

					while(1){
						fgets(buf, 256, fp_org);
						k = sscanf(buf, "%d %f %f %f %f %f", &R_No,
							   	   &length, &Org_width, &deg,
								   &a, &b);
						if(k == 6){
							New_width = rate * obj_Uarea[i] +
								least_width;

							fprintf(fp_mod, "\t \t%d %f %f %f %f %f\n",
									R_No, length, New_width,
									deg, a, b);
							continue;
						}
						else break;
					}
					//$B2OF;$N%Q%i%a%?$r5-$7$?9T$H!"<PLL%b%G%kL>Ey(B
					//$B$r5-$7$?9T$H$N4V$N2~9T%^!<%/$r=q$/!#(B
					fprintf(fp_mod, "%s", buf);

				}
				if(flag_hit == 1) break;
			}
		}
		else{
			//$B<PLL%b%G%k$N%Q%i%a%?$r5-$7$?9T$N<!$N9T$N2~9T%^!<%/(B
			//$B$r=q$/(B
			fprintf(fp_mod, "%s", buf);
			continue;
		}
	}
	fclose(fp_org);
	fclose(fp_mod);
}
